#include <iostream>
using namespace std;
/* run this program using the console pauser or add your own getch, system("pause") or input loop */

#define dim 100000

int n, m;

void ispisi(int a[dim][dim]){
	for(int i=0;i<n+1;i++){
		for(int j=0;j<m+1;j++){
			cout<<a[i][j]<<" ";
		}
		cout<<endl;
	}
}

void dp1(int a[dim][dim]){
	for(int i=1;i<=m;i++){
		a[1][i]+=a[1][i-1];
	}
	for(int i=1;i<=n;i++){
		a[i][1]+=a[i-1][1];
	}
	for(int i=2;i<=n;i++){
		for(int j=1;j<=m;j++){
			if(a[i][j-1]<a[i-1][j]){
				a[i][j]+=a[i][j-1];
			}
			else{
				a[i][j]+=a[i-1][j];
			}
		}
	}
}

int dp(int x, int y, int a[dim][dim]){
	int b[dim][dim];
	for(int i=0;i<=n;i++){
		for(int j=0;j<=m;j++){
			b[i][j]=a[i][j];
		}
	}
	b[x][y]=1000000000;
	dp1(b);
	//ispisi(b);
	return b[n][m];
}

int main(int argc, char** argv) {
	int x, y;
	int q;
	cin>>n>>m;
	int a[dim][dim];
	for(int i=0;i<n;i++){
		a[i][0]=0;
	}
	for(int i=0;i<m;i++){
		a[0][i]=0;
	}
	for(int i=1;i<n+1;i++){
		for(int j=1;j<m+1;j++){
			cin>>a[i][j];
		}
	}
	cin>>q;
	for(int i=0;i<q;i++){
		cin>>x>>y;
		int k=dp(x, y, a);
		cout<<k<<endl;
	}
	return 0;
}